﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FlightPlan.Optimizer.Wfs
{
    public class BoundingBox
    {
        #region - Constructors -

        public BoundingBox()
        {

        }

        public BoundingBox(double lat1, double lon1, double lat2, double lon2)
        {
            this.Lat1 = lat1;
            this.Lon1 = lon1;
            this.Lat2 = lat2;
            this.Lon2 = lon2;
        }

        #endregion
        #region - Properties -

        public double Lat1 { get; set; }
        public double Lon1 { get; set; }
        public double Lat2 { get; set; }
        public double Lon2 { get; set; }

        #endregion
        #region - Public -

        public bool IsInside(Waypoint wp)
        {
            if(wp == null)
                return false;

            double lat = wp.latitude.AsDouble();
            if (lat < Lat1 || lat > Lat2)
            {
                return false;
            }

            double lon = wp.longitude.AsDouble();
            if (lon < Lon1 || lon > Lon2)
            {
                return false;
            }

            return true;
        }

        #endregion
    }
}
