// Condition.cs created with MonoDevelop
// User: esantama at 12:09 PM 10/9/2008

using System;

namespace FlightPlan
{
	/// <summary>
	/// Implements a flight plan condition.
	/// </summary>
	public class Condition
    {
        #region - Attributes -

        // id of the condition.
		private string id;
		private int? result;

        #endregion
        #region - Constructor -

        /// <summary>
		/// Constructor.
		/// </summary>
		/// <remarks>Condition result is set to null.</remarks>
		/// <param name="id">A <see cref="System.String"/> with the condition identifier.</param>
		public Condition(string id)
		{
			this.id = id;
			result = null;
		}

        #endregion
        #region - Properties -

		/// <summary>
		/// Returns condition id.
		/// </summary>
		public string CondId 
        {
			get { return id; }
		}

        #endregion
        #region - Public Functions -


        /// <summary>
		/// Sets condition result.
		/// </summary>
		/// <param name="r">A <see cref="System.Int32"/> with the result.</param>		
		public void SetResult(int r)
		{
			result = r;
		}

		
		/// <summary>
		/// Returns condition result.
		/// </summary>		
		public int GetResult()
		{
			return result.Value;
		}
		
		/// <summary>
		/// Returns true if the condition has been initialized, false otherwise.
		/// </summary>		
		public bool HasResult()
		{
			return (result != null);
        }

        #endregion
    }
}
