// /home/esantama/DevProjs/mono/FPManager/Angles.cs created with MonoDevelop
// User: esantama at 9:34 AM 11/28/2007

using System;

namespace Utils
{
	
	/// <summary>
	/// Angles related computations.
	/// </summary>
	public static class Angles
	{

        /// <summary>
        /// TBD
        /// </summary>
        /// <param name="angle"></param>
        /// <returns></returns>
		public static double DegToRad(double angle)
		{
			return angle*Math.PI/180;
		}

        /// <summary>
        /// TBD
        /// </summary>
        /// <param name="angle"></param>
        /// <returns></returns>
		public static double RadToDeg(double angle)
		{
			return angle*180/Math.PI;
		}
		
        /// <summary>
        /// TBD
        /// </summary>
        /// <param name="angle"></param>
        /// <returns></returns>
		public static double Normalize(double angle)
		{
			// normalize angle
			angle = (angle%360);
			if (angle <= 0) angle = angle + 360;
			return angle;
		}
		
        /// <summary>
        /// Returns absolute distance (in degrees) between two angles.
        /// </summary>
        /// <param name="orig"></param>
        /// <param name="dest"></param>
        /// <param name="turnLeft"></param>
        /// <returns></returns>
		public static double AbsDistance(double orig, double dest, bool turnLeft)
		{
			// Normalize angles
			orig  = Normalize(orig);
			dest  = Normalize(dest);
			
			double angle = 0;
					
			if (turnLeft)
            {
				if (dest <= orig) angle = orig - dest;
				else			  angle = 360 - (dest - orig);
			} 
            else 
            {
				if (dest >= orig) angle = dest - orig;
				else		      angle = 360 - (orig - dest);
			}
			
			return angle;
		}

        /// <summary>
        /// Returns relative distance (in degrees) between two angles. 
        /// </summary>
        /// <param name="orig"></param>
        /// <param name="dest"></param>
        /// <returns></returns>
		public static double Distance(double orig, double dest)
		{			
			// Normalize angles
			orig  = Normalize(orig);
			dest  = Normalize(dest);
			
			return Normalize(dest - orig);
		}
		
        /// <summary>
        /// TBD
        /// </summary>
        /// <param name="angle"></param>
        /// <param name="r"></param>
        /// <returns></returns>
		public static double ArcLength(double angle, double r)
		{
			return DegToRad(angle)*r;
		}		
	}
}
