﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.IO;
using FlightPlan;

namespace FlightPlanXMLTests
{
    public static class ResourceReader
    {

        /// <summary>
        /// Helper method for loading a flight plan.
        /// </summary>
        /// <param name="fileName"></param>
        /// <returns></returns>
        public static FlightPlan.FlightPlan LoadFP(string fileName)
        {
            // Load flight plan contents into xml_contents
            Assembly asm = Assembly.GetExecutingAssembly();
            Stream str = asm.GetManifestResourceStream(fileName);
            string xml_contents = new StreamReader(str).ReadToEnd();

            // Parse flight plan
            XMLFPParser fp_parser = new XMLFPParser();
            fp_parser.SetContent(xml_contents);
            return fp_parser.Parse();
        }

        /// <summary>
        /// Helper method for loading an XML update to the flight plan.
        /// </summary>
        /// <param name="fileName"></param>
        /// <returns></returns>
        public static string LoadUpdate(string fileName)
        {
            // Load flight plan contents into xml_contents
            Assembly asm = Assembly.GetExecutingAssembly();
            Stream str = asm.GetManifestResourceStream(fileName);
            string xml_contents = new StreamReader(str).ReadToEnd();

            return xml_contents;
        }

    }
}
