﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Tsp.BB
{
    public class State3 : State
    {
        #region - Attributes -

        /// <summary>
        /// Reduced adyacency matrix
        /// </summary>
        public int[,] m;  // matriz de adyacencia reducida
        //public int reducido;

        #endregion
        #region - Constructors -

        /// <summary>
        /// Constructor inicial.
        /// </summary>
        /// <param name="g">El grafo para sacar la matriz de adyacencia</param>
        public State3(Graph g)
            :base() // iniciamos los otros atributos a 1
        {
            this.m     = g.CreateAdyMatrix();
            this.value = Utils.Reduce(this.m);
            //this.reducido = this.value;
        }


        public State3(State3 parent, int idNewNode)
            :base(parent, idNewNode, -1)
        {
            this.m = Utils.Copy(parent.m);

            int i = this.path[this.k - 2]; // ultimo enlace
            int j = this.path[this.k - 1];
            int valueIJ = this.m[i, j];

            // Ultimo arco es {i, j}
             valueIJ = TheGraph.GetNode(i).links[j].weight;

            // a)
            int nn = this.m.GetLength(0);
            for (int l = 0; l < nn; l++)
            {
                this.m[i, l] = int.MaxValue;
                this.m[l, j] = int.MaxValue;
            }

            // b)
            this.m[j, 1] = int.MaxValue;

            // bla bla con m

            this.value = parent.value + Utils.Reduce(this.m) + valueIJ;
        }

        #endregion
        #region - Public -
              

        public override List<State> Branch()
        {
            int currentNode = path[k - 1];
            Node n = TheGraph.GetNode(currentNode);
            Link l;

            if (this.k == N) // Is Solution?
            {
                l = n.GetLinkWith(this.path[0]);
                if (l != null)
                {
                    this.value += l.weight;/////////////////////////
                    if (this.value < State.BestValue) // if we have found a best solution, saved it
                    {
                        BestSolution = this;
                        BestValue = this.value;
                    }
                }
                return null;
            }
            else
            {
                List<State> list = null;
                int id2;

                for (n.ResetIterator(); !n.EndIterator(); )
                {
                    l = n.NextLink();
                    id2 = l.node2.id;
                    if (this.m[n.id, id2] != int.MaxValue)//   !this.PathContainsNode(id2))
                    {
                        if (this.value + l.weight < State.BestValue)
                        {
                            State3 s2 = new State3(this, id2);
                            if (s2.value < State.BestValue)
                            {
                                if (list == null)
                                    list = new List<State>();
                                list.Add(s2);
                            }
                            else
                            {
                                State.NbPruned++;
                            }
                        }
                        else
                        {
                            State.NbPruned++;
                        }
                    }
                }
                return list;
            }
        }


        #endregion                
    }
}
