//////////////////////////////////////////////////////////////////////////////////////////////////
// File Name: Link.cs
//      Date: 06/01/2006
// Copyright (c) 2006 Michael LaLena. All rights reserved.  (www.lalena.com)
// Permission to use, copy, modify, and distribute this Program and its documentation,
//  if any, for any purpose and without fee is hereby granted, provided that:
//   (i) you not charge any fee for the Program, and the Program not be incorporated
//       by you in any software or code for which compensation is expected or received;
//   (ii) the copyright notice listed above appears in all copies;
//   (iii) both the copyright notice and this Agreement appear in all supporting documentation; and
//   (iv) the name of Michael LaLena or lalena.com not be used in advertising or publicity
//          pertaining to distribution of the Program without specific, written prior permission. 
///////////////////////////////////////////////////////////////////////////////////////////////////
using System;
using System.Collections.Generic;
using System.Text;

namespace Tsp.GA
{
    /// <summary>
    /// An individual link between 2 cities in a tour.
    /// This city connects to 2 other cities.
    /// </summary>
    public class Link
    {
        #region - Attributes -

        /// <summary>
        /// Connection to the first city.
        /// </summary>
        private int connection1;

        /// <summary>
        /// Connection to the second city.
        /// </summary>
        private int connection2;

        /// <summary>
        /// The weight for this connection.
        /// </summary>
        private double weight;

        #endregion
        #region - Properties -

        /// <summary>
        /// Connection to the first city.
        /// </summary>
        public int Connection1
        {
            get { return connection1; }
            set { connection1 = value;}
        }

        /// <summary>
        /// Connection to the second city.
        /// </summary>
        public int Connection2
        {
            get { return connection2; }
            set { connection2 = value; }
        }

        /// <summary>
        /// The weight for this connection.
        /// </summary>
        public double Weight
        {
            get { return weight; }
            set { weight = value; }
        }

        #endregion
    }
}
