﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Tsp
{
    /// <summary>
    /// Represents a Link in a Graph.
    /// </summary>
    /// <author>Santiago Jiménez Serrano [sanjiser@gmail.com]</author>
    public class Link
    {
        #region - Attributes -

        /// <summary>
        /// The first  node
        /// </summary>
        public Node  node1;  

        /// <summary>
        /// The second node
        /// </summary>
        public Node  node2;

        /// <summary>
        /// The weight for this link
        /// </summary>
        public int  weight;

        #endregion
        #region - Constructors -

        /// <summary>
        /// Creates a new instance of Link.
        /// </summary>
        /// <param name="n1">The first link node.</param>
        /// <param name="n2">The second link node.</param>
        /// <param name="weight">The weight for this Link.</param>
        public Link(Node n1, Node n2, int weight)
        {
            this.node1  = n1;
            this.node2  = n2;
            this.weight = weight;
        }

        #endregion
        #region - Public -

        /// <summary>
        /// Gets a String representation for this Link.
        /// </summary>
        /// <returns>The String representation for this Link.</returns>
        public override String ToString()
        {
            return node1.id + "\t" + node2.id + "\t" + weight;
        }

        #endregion
    }
}
